diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/buildings/model/three-gpp-v2v-channel-condition-model.cc ns-3.33/src/buildings/model/three-gpp-v2v-channel-condition-model.cc
--- ns-3.32/src/buildings/model/three-gpp-v2v-channel-condition-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/buildings/model/three-gpp-v2v-channel-condition-model.cc	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,207 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ * Copyright (c) 2020 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "three-gpp-v2v-channel-condition-model.h"
+#include "ns3/mobility-model.h"
+#include "ns3/log.h"
+#include <ns3/building-list.h>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ThreeGppV2vChannelConditionModel");
+
+NS_OBJECT_ENSURE_REGISTERED (ThreeGppV2vUrbanChannelConditionModel);
+
+TypeId
+ThreeGppV2vUrbanChannelConditionModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::ThreeGppV2vUrbanChannelConditionModel")
+    .SetParent<ThreeGppChannelConditionModel> ()
+    .SetGroupName ("Buildings")
+    .AddConstructor<ThreeGppV2vUrbanChannelConditionModel> ()
+  ;
+  return tid;
+}
+
+ThreeGppV2vUrbanChannelConditionModel::ThreeGppV2vUrbanChannelConditionModel ()
+  : ThreeGppChannelConditionModel ()
+{
+  m_buildingsCcm = CreateObject<BuildingsChannelConditionModel> ();
+}
+
+ThreeGppV2vUrbanChannelConditionModel::~ThreeGppV2vUrbanChannelConditionModel ()
+{}
+
+double
+ThreeGppV2vUrbanChannelConditionModel::ComputePlos (Ptr<const MobilityModel> a,
+                                                    Ptr<const MobilityModel> b) const
+{
+  NS_LOG_FUNCTION (this);
+
+  // determine if there is a building in between the tx and rx
+  Ptr<ChannelCondition> cond = m_buildingsCcm->GetChannelCondition (a, b);
+  NS_ASSERT_MSG (cond->IsO2o (), "The nodes should be outdoor");
+
+  double pLos = 0.0;
+  if (cond->IsLos ())
+    {
+      // compute the 2D distance between a and b
+      double distance2D = Calculate2dDistance (a->GetPosition (), b->GetPosition ());
+
+      // compute the LOS probability (see 3GPP TR 37.885, Table 6.2-1)
+      pLos = std::min (1.0, 1.05 * exp (-0.0114 * distance2D));
+    }
+
+  return pLos;
+}
+
+double
+ThreeGppV2vUrbanChannelConditionModel::ComputePnlos (Ptr<const MobilityModel> a,
+                                                     Ptr<const MobilityModel> b) const
+{
+  NS_LOG_FUNCTION (this);
+
+  // determine the NLOS due to buildings
+  Ptr<ChannelCondition> cond = m_buildingsCcm->GetChannelCondition (a, b);
+  NS_ASSERT_MSG (cond->IsO2o (), "The nodes should be outdoor");
+
+  double pNlos = 0.0;
+  if (cond->IsNlos ())
+    {
+      pNlos = 1.0;
+    }
+
+  return pNlos;
+}
+
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED (ThreeGppV2vHighwayChannelConditionModel);
+
+TypeId
+ThreeGppV2vHighwayChannelConditionModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::ThreeGppV2vHighwayChannelConditionModel")
+    .SetParent<ThreeGppChannelConditionModel> ()
+    .SetGroupName ("Buildings")
+    .AddConstructor<ThreeGppV2vHighwayChannelConditionModel> ()
+  ;
+  return tid;
+}
+
+ThreeGppV2vHighwayChannelConditionModel::ThreeGppV2vHighwayChannelConditionModel ()
+  : ThreeGppChannelConditionModel ()
+{
+  m_buildingsCcm = CreateObject<BuildingsChannelConditionModel> ();
+  ComputeChCond = std::bind (&ThreeGppV2vHighwayChannelConditionModel::GetChCondAndFixCallback, this,
+                             std::placeholders::_1, std::placeholders::_2);
+}
+
+ThreeGppV2vHighwayChannelConditionModel::~ThreeGppV2vHighwayChannelConditionModel ()
+{}
+
+double
+ThreeGppV2vHighwayChannelConditionModel::ComputePlos (Ptr<const MobilityModel> a,
+                                                      Ptr<const MobilityModel> b) const
+{
+  NS_LOG_FUNCTION (this);
+
+  // determine if there is a building in between the tx and rx
+  Ptr<ChannelCondition> cond = ComputeChCond (a, b);
+  NS_ASSERT_MSG (cond->IsO2o (), "The nodes should be outdoor");
+
+  double pLos = 0.0;
+  if (cond->IsLos ())
+    {
+      // compute the 2D distance between a and b
+      double distance2D = Calculate2dDistance (a->GetPosition (), b->GetPosition ());
+
+      // compute the LOS probability (see 3GPP TR 37.885, Table 6.2-1)
+      if (distance2D <= 475.0)
+        {
+          pLos = std::min (1.0, 2.1013e-6 * distance2D * distance2D - 0.002 * distance2D + 1.0193);
+        }
+      else
+        {
+          pLos = std::max (0.0, 0.54 - 0.001 * (distance2D - 475.0));
+        }
+    }
+
+  return pLos;
+}
+
+double
+ThreeGppV2vHighwayChannelConditionModel::ComputePnlos (Ptr<const MobilityModel> a,
+                                                       Ptr<const MobilityModel> b) const
+{
+  NS_LOG_FUNCTION (this);
+
+  // determine the NLOS due to buildings
+  Ptr<ChannelCondition> cond = ComputeChCond (a, b);
+  NS_ASSERT_MSG (cond->IsO2o (), "The nodes should be outdoor");
+
+  double pNlos = 0;
+  if (cond->IsNlos ())
+    {
+      pNlos = 1.0;
+    }
+
+  return pNlos;
+}
+
+Ptr<ChannelCondition>
+ThreeGppV2vHighwayChannelConditionModel::GetChCondAndFixCallback (Ptr<const MobilityModel> a,
+                                                                   Ptr<const MobilityModel> b)
+{
+  Ptr<ChannelCondition> cond;
+  if (BuildingList::Begin () != BuildingList::End ())
+    {
+      ComputeChCond = std::bind (&ThreeGppV2vHighwayChannelConditionModel::GetChCondWithBuildings, this,
+                                 std::placeholders::_1, std::placeholders::_2);
+      cond = GetChCondWithBuildings (a, b);
+    }
+  else
+    {
+      ComputeChCond = std::bind (&ThreeGppV2vHighwayChannelConditionModel::GetChCondWithNoBuildings, this,
+                                 std::placeholders::_1, std::placeholders::_2);
+      cond = GetChCondWithNoBuildings (a, b);
+    }
+  return cond;
+}
+
+Ptr<ChannelCondition>
+ThreeGppV2vHighwayChannelConditionModel::GetChCondWithBuildings (Ptr<const MobilityModel> a,
+                                                                  Ptr<const MobilityModel> b) const
+{
+  Ptr<ChannelCondition> cond = m_buildingsCcm->GetChannelCondition (a, b);
+  return cond;
+}
+
+Ptr<ChannelCondition>
+ThreeGppV2vHighwayChannelConditionModel::GetChCondWithNoBuildings (Ptr<const MobilityModel> a,
+                                                                    Ptr<const MobilityModel> b) const
+{
+  Ptr<ChannelCondition> cond = CreateObject<ChannelCondition> ();
+  cond->SetO2iCondition (ChannelCondition::O2iConditionValue::O2O);
+  cond->SetLosCondition (ChannelCondition::LosConditionValue::LOS);
+  return cond;
+}
+
+} // end namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/buildings/model/three-gpp-v2v-channel-condition-model.h ns-3.33/src/buildings/model/three-gpp-v2v-channel-condition-model.h
--- ns-3.32/src/buildings/model/three-gpp-v2v-channel-condition-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/buildings/model/three-gpp-v2v-channel-condition-model.h	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,208 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ * Copyright (c) 2020 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef THREE_GPP_V2V_CHANNEL_CONDITION_MODEL
+#define THREE_GPP_V2V_CHANNEL_CONDITION_MODEL
+
+#include "ns3/channel-condition-model.h"
+#include "buildings-channel-condition-model.h"
+#include <functional>
+
+namespace ns3 {
+
+class MobilityModel;
+
+/**
+ * \ingroup buildings
+ *
+ * \brief Computes the channel condition for the V2V Urban scenario
+ *
+ * Computes the channel condition following the specifications for the
+ * V2V Urban scenario reported in Table 6.2-1 of 3GPP TR 37.885.
+ *
+ * 3GPP TR 37.885 defines 3 different channel states for vehicular environments:
+ * LOS, NLOS and NLOSv, the latter representing the case in which the LOS path is
+ * blocked by other vehicles in the scenario. The document defines a probabilistic
+ * model to determine if the channel state is LOS or NLOSv, while the NLOS state
+ * is determined in a deterministic way based on the buildings deployed in the
+ * scenario. For this reason, this class makes use of an instance of
+ * BuildingsChannelConditionModel to determine if the LOS is obstructed by
+ * buildings or not.
+ */
+class ThreeGppV2vUrbanChannelConditionModel : public ThreeGppChannelConditionModel
+{
+public:
+  /**
+   * Get the type ID.
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * Constructor for the ThreeGppV2vUrbanChannelConditionModel class
+   */
+  ThreeGppV2vUrbanChannelConditionModel ();
+
+  /**
+   * Destructor for the ThreeGppV2vUrbanChannelConditionModel class
+   */
+  virtual ~ThreeGppV2vUrbanChannelConditionModel () override;
+
+private:
+  /**
+   * Compute the LOS probability as specified in Table Table 6.2-1 of 3GPP TR 37.885
+   * for the V2V Urban scenario.
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the LOS probability
+   */
+  virtual double ComputePlos (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+
+  /**
+   * Compute the NLOS probability. It determines the presence of obstructions
+   * between the tx and the rx based on the buildings deployed in the scenario.
+   * It returns 1 if the LOS path is obstructed, 0 otherwise.
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the NLOS probability
+   */
+  virtual double ComputePnlos (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+
+  Ptr<BuildingsChannelConditionModel> m_buildingsCcm; //!< used to determine the obstructions due to buildings
+};
+
+/**
+ * \ingroup buildings
+ *
+ * \brief Computes the channel condition for the V2V Highway scenario
+ *
+ * Computes the channel condition following the specifications for the
+ * V2V Highway scenario reported in Table 6.2-1 of 3GPP TR 37.885.
+ *
+ * 3GPP TR 37.885 defines 3 different channel states for vehicular environments:
+ * LOS, NLOS and NLOSv, the latter representing the case in which the LOS path is
+ * blocked by other vehicles in the scenario. The document defines a probabilistic
+ * model to determine if the channel state is LOS or NLOSv, while the NLOS state
+ * is determined in a deterministic way based on the buildings deployed in the
+ * scenario. For this reason, this class makes use of an instance of
+ * BuildingsChannelConditionModel to determine if the LOS is obstructed by
+ * buildings or not.
+ */
+class ThreeGppV2vHighwayChannelConditionModel : public ThreeGppChannelConditionModel
+{
+public:
+  /**
+   * Get the type ID.
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * Constructor for the ThreeGppV2vHighwayChannelConditionModel class
+   */
+  ThreeGppV2vHighwayChannelConditionModel ();
+
+  /**
+   * Destructor for the ThreeGppV2vHighwayChannelConditionModel class
+   */
+  virtual ~ThreeGppV2vHighwayChannelConditionModel () override;
+
+private:
+  /**
+   * Compute the LOS probability as specified in Table Table 6.2-1 of 3GPP TR 37.885
+   * for the V2V Highway scenario.
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the LOS probability
+   */
+  virtual double ComputePlos (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+
+  /**
+   * Compute the NLOS probability. It determines the presence of obstructions
+   * between the tx and the rx based on the buildings deployed in the scenario.
+   * It returns 1 if the LOS path is obstructed, 0 otherwise.
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the NLOS probability
+   */
+  virtual double ComputePnlos (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+
+  /**
+   * \brief The callback which is hooked to a method to compute channel condition.
+   *
+   * This callback is implemented to make this model robust against the
+   * presence and absence of buildings in a highway scenario. If there are
+   * buildings in a scenario, this model will use
+   * \link BuildingsChannelConditionModel \endlink, which requires
+   * \link MobilityBuildingInfo \endlink aggregated to the nodes to compute
+   * LOS and NLOS. Otherwise, the callback is hooked to a local method
+   * \link GetChaCondWithNoBuildings \endlink
+   * , which construct the ChannelCondtion object and set the condition to
+   * outdoor to outdoor with LOS.
+   */
+  std::function <Ptr<ChannelCondition> (Ptr<const MobilityModel>, Ptr<const MobilityModel>) > ComputeChCond;
+
+  /**
+   * \brief Get the channel condition and redirect the callback
+   * \link ComputeChCond \endlink to \link GetChaCondWithBuildings \endlink
+   * or to \link GetChaCondWithNoBuildings \endlink depending on if there are
+   * buildings in the scenario or not.
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the the condition of the channel between \p a and \p b
+   */
+  Ptr<ChannelCondition> GetChCondAndFixCallback (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b);
+
+  /**
+   * \brief Get the channel condition between \p a and \p b
+   *        using BuildingsChannelConditionModel.
+   *
+   * This method will be called for the scenarios with buildings
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the condition of the channel between \p a and \p b
+   */
+  Ptr<ChannelCondition> GetChCondWithBuildings (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const;
+
+  /**
+   * \brief Get the channel condition between \p a and \p b
+   *
+   * This method will be called for the scenarios without buildings
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the condition of the channel between \p a and \p b
+   */
+  Ptr<ChannelCondition> GetChCondWithNoBuildings (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const;
+
+  Ptr<BuildingsChannelConditionModel> m_buildingsCcm; //!< used to determine the obstructions due to buildings
+};
+
+} // end ns3 namespace
+
+#endif /* THREE_GPP_V2V_CHANNEL_CONDITION_MODEL */
